---
title: Images
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/typescript)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Images

#### ImagesV1

##### [List images](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/methods/list)

Deprecated

client.images.v1.list(V1ListParams {account\_id, creator, page, per\_page } params, RequestOptionsoptions?): V4PagePagination< [V1ListResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1%20%3E%20(model)%20v1_list_response%20%3E%20(schema)>) {images } >

GET/accounts/{account\_id}/images/v1

##### [Image details](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/methods/get)

client.images.v1.get(stringimageID, V1GetParams {account\_id } params, RequestOptionsoptions?): [Image](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)>) {id, creator, filename, 4 more }

GET/accounts/{account\_id}/images/v1/{image\_id}

##### [Upload an image](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/methods/create)

client.images.v1.create(V1CreateParams {account\_id, id, creator, 4 more } params, RequestOptionsoptions?): [Image](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)>) {id, creator, filename, 4 more }

POST/accounts/{account\_id}/images/v1

##### [Update image](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/methods/edit)

client.images.v1.edit(stringimageID, V1EditParams {account\_id, creator, metadata, requireSignedURLs } params, RequestOptionsoptions?): [Image](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)>) {id, creator, filename, 4 more }

PATCH/accounts/{account\_id}/images/v1/{image\_id}

##### [Delete image](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/methods/delete)

client.images.v1.delete(stringimageID, V1DeleteParams {account\_id } params, RequestOptionsoptions?): [V1DeleteResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1%20%3E%20(model)%20v1_delete_response%20%3E%20(schema)>)

DELETE/accounts/{account\_id}/images/v1/{image\_id}

##### ModelsExpand Collapse

<details>

<summary>

Image {id, creator, filename, 4 more }

</summary>

id?: string

Image unique identifier.

maxLength32

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

creator?: string| null

Can set the creator field with an internal user ID.

maxLength1024

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20creator">Link to this property</a>

filename?: string

Image file name.

maxLength255

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20filename">Link to this property</a>

meta?: unknown

User modifiable key-value store. Can be used for keeping references to another system of record for managing images. Metadata must not exceed 1024 bytes.

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20meta">Link to this property</a>

requireSignedURLs?: boolean

Indicates whether the image can be a accessed only using it’s UID. If set to true, a signed token needs to be generated with a signing key to view the image.

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20requireSignedURLs">Link to this property</a>

uploaded?: string

When the media item was uploaded.

formatdate-time

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20uploaded">Link to this property</a>

variants?: Array&lt;string&gt;

Object specifying available variants for an image.

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20variants">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)>)

<details>

<summary>

V1ListResponse {images }

</summary>

<details>

<summary>

images?: Array&lt;<a href="https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)">Image</a> {id, creator, filename, 4 more } &gt;

</summary>

id?: string

Image unique identifier.

maxLength32

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

creator?: string| null

Can set the creator field with an internal user ID.

maxLength1024

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20creator">Link to this property</a>

filename?: string

Image file name.

maxLength255

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20filename">Link to this property</a>

meta?: unknown

User modifiable key-value store. Can be used for keeping references to another system of record for managing images. Metadata must not exceed 1024 bytes.

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20meta">Link to this property</a>

requireSignedURLs?: boolean

Indicates whether the image can be a accessed only using it’s UID. If set to true, a signed token needs to be generated with a signing key to view the image.

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20requireSignedURLs">Link to this property</a>

uploaded?: string

When the media item was uploaded.

formatdate-time

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20uploaded">Link to this property</a>

variants?: Array&lt;string&gt;

Object specifying available variants for an image.

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20variants">Link to this property</a>

</details>

<a href="#(resource)%20images.v1%20%3E%20(model)%20v1_list_response%20%3E%20(schema)%20%3E%20(property)%20images">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1%20%3E%20(model)%20v1_list_response%20%3E%20(schema)>)

<details>

<summary>

V1DeleteResponse = unknown| string

</summary>

One of the following:

unknown

<a href="#(resource)%20images.v1%20%3E%20(model)%20v1_delete_response%20%3E%20(schema)%20%3E%20(variant)%200">Link to this property</a>

string

<a href="#(resource)%20images.v1%20%3E%20(model)%20v1_delete_response%20%3E%20(schema)%20%3E%20(variant)%201">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1%20%3E%20(model)%20v1_delete_response%20%3E%20(schema)>)

#### ImagesV1Keys

##### [List Signing Keys](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/keys/methods/list)

client.images.v1.keys.list(KeyListParams {account\_id } params, RequestOptionsoptions?): [KeyListResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.keys%20%3E%20(model)%20key_list_response%20%3E%20(schema)>) {keys }

GET/accounts/{account\_id}/images/v1/keys

##### [Create a new Signing Key](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/keys/methods/update)

client.images.v1.keys.update(stringsigningKeyName, KeyUpdateParams {account\_id } params, RequestOptionsoptions?): [KeyUpdateResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.keys%20%3E%20(model)%20key_update_response%20%3E%20(schema)>) {keys }

PUT/accounts/{account\_id}/images/v1/keys/{signing\_key\_name}

##### [Delete Signing Key](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/keys/methods/delete)

client.images.v1.keys.delete(stringsigningKeyName, KeyDeleteParams {account\_id } params, RequestOptionsoptions?): [KeyDeleteResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.keys%20%3E%20(model)%20key_delete_response%20%3E%20(schema)>) {keys }

DELETE/accounts/{account\_id}/images/v1/keys/{signing\_key\_name}

##### ModelsExpand Collapse

<details>

<summary>

Key {name, value }

</summary>

name?: string

Key name.

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

value?: string

Key value.

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)%20%3E%20(property)%20value">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)>)

<details>

<summary>

KeyListResponse {keys }

</summary>

<details>

<summary>

keys?: Array&lt;<a href="https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)">Key</a> {name, value } &gt;

</summary>

name?: string

Key name.

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

value?: string

Key value.

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key_list_response%20%3E%20(schema)%20%3E%20(property)%20keys">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.keys%20%3E%20(model)%20key_list_response%20%3E%20(schema)>)

<details>

<summary>

KeyUpdateResponse {keys }

</summary>

<details>

<summary>

keys?: Array&lt;<a href="https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)">Key</a> {name, value } &gt;

</summary>

name?: string

Key name.

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

value?: string

Key value.

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key_update_response%20%3E%20(schema)%20%3E%20(property)%20keys">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.keys%20%3E%20(model)%20key_update_response%20%3E%20(schema)>)

<details>

<summary>

KeyDeleteResponse {keys }

</summary>

<details>

<summary>

keys?: Array&lt;<a href="https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)">Key</a> {name, value } &gt;

</summary>

name?: string

Key name.

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

value?: string

Key value.

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key%20%3E%20(schema)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.keys%20%3E%20(model)%20key_delete_response%20%3E%20(schema)%20%3E%20(property)%20keys">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.keys%20%3E%20(model)%20key_delete_response%20%3E%20(schema)>)

#### ImagesV1Stats

##### [Images usage statistics](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/stats/methods/get)

client.images.v1.stats.get(StatGetParams {account\_id } params, RequestOptionsoptions?): [Stat](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.stats%20%3E%20(model)%20stat%20%3E%20(schema)>) {count }

GET/accounts/{account\_id}/images/v1/stats

##### ModelsExpand Collapse

<details>

<summary>

Stat {count }

</summary>

<details>

<summary>

count?: Count {allowed, current }

</summary>

allowed?: number

Cloudflare Images allowed usage.

<a href="#(resource)%20images.v1.stats%20%3E%20(model)%20stat%20%3E%20(schema)%20%3E%20(property)%20count%20%3E%20(property)%20allowed">Link to this property</a>

current?: number

Cloudflare Images current usage.

<a href="#(resource)%20images.v1.stats%20%3E%20(model)%20stat%20%3E%20(schema)%20%3E%20(property)%20count%20%3E%20(property)%20current">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.stats%20%3E%20(model)%20stat%20%3E%20(schema)%20%3E%20(property)%20count">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.stats%20%3E%20(model)%20stat%20%3E%20(schema)>)

#### ImagesV1Variants

##### [List variants](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/variants/methods/list)

client.images.v1.variants.list(VariantListParams {account\_id } params, RequestOptionsoptions?): [Variant](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)>) {variants }

GET/accounts/{account\_id}/images/v1/variants

##### [Variant details](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/variants/methods/get)

client.images.v1.variants.get(stringvariantID, VariantGetParams {account\_id } params, RequestOptionsoptions?): [VariantGetResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)>) {variant }

GET/accounts/{account\_id}/images/v1/variants/{variant\_id}

##### [Create a variant](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/variants/methods/create)

client.images.v1.variants.create(VariantCreateParams {account\_id, id, options, neverRequireSignedURLs } params, RequestOptionsoptions?): [VariantCreateResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)>) {variant }

POST/accounts/{account\_id}/images/v1/variants

##### [Update a variant](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/variants/methods/edit)

client.images.v1.variants.edit(stringvariantID, VariantEditParams {account\_id, options, neverRequireSignedURLs } params, RequestOptionsoptions?): [VariantEditResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)>) {variant }

PATCH/accounts/{account\_id}/images/v1/variants/{variant\_id}

##### [Delete a variant](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/variants/methods/delete)

client.images.v1.variants.delete(stringvariantID, VariantDeleteParams {account\_id } params, RequestOptionsoptions?): [VariantDeleteResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1.variants%20%3E%20(model)%20variant_delete_response%20%3E%20(schema)>)

DELETE/accounts/{account\_id}/images/v1/variants/{variant\_id}

##### ModelsExpand Collapse

<details>

<summary>

Variant {variants }

</summary>

<details>

<summary>

variants?: Variants {hero }

</summary>

<details>

<summary>

hero?: Hero {id, options, neverRequireSignedURLs }

</summary>

id: string

maxLength99

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

options: Options {fit, height, metadata, width }

Allows you to define image resizing sizes for different use cases.

</summary>

<details>

<summary>

fit: "scale-down"| "contain"| "cover"| 2 more

The fit property describes how the width and height dimensions should be interpreted.

</summary>

One of the following:

"scale-down"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%200">Link to this property</a>

"contain"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%201">Link to this property</a>

"cover"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%202">Link to this property</a>

"crop"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%203">Link to this property</a>

"pad"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%204">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20fit">Link to this property</a>

height: number

Maximum height in image pixels.

minimum1

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20height">Link to this property</a>

<details>

<summary>

metadata: "keep"| "copyright"| "none"

What EXIF data should be preserved in the output image.

</summary>

One of the following:

"keep"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%200">Link to this property</a>

"copyright"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%201">Link to this property</a>

"none"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20metadata">Link to this property</a>

width: number

Maximum width in image pixels.

minimum1

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options%20%3E%20(property)%20width">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20options">Link to this property</a>

neverRequireSignedURLs?: boolean

Indicates whether the variant can access an image without a signature, regardless of image access control.

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero%20%3E%20(property)%20neverRequireSignedURLs">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants%20%3E%20(property)%20hero">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)%20%3E%20(property)%20variants">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.variants%20%3E%20(model)%20variant%20%3E%20(schema)>)

<details>

<summary>

VariantGetResponse {variant }

</summary>

<details>

<summary>

variant?: Variant {id, options, neverRequireSignedURLs }

</summary>

id: string

maxLength99

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

options: Options {fit, height, metadata, width }

Allows you to define image resizing sizes for different use cases.

</summary>

<details>

<summary>

fit: "scale-down"| "contain"| "cover"| 2 more

The fit property describes how the width and height dimensions should be interpreted.

</summary>

One of the following:

"scale-down"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%200">Link to this property</a>

"contain"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%201">Link to this property</a>

"cover"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%202">Link to this property</a>

"crop"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%203">Link to this property</a>

"pad"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%204">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit">Link to this property</a>

height: number

Maximum height in image pixels.

minimum1

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20height">Link to this property</a>

<details>

<summary>

metadata: "keep"| "copyright"| "none"

What EXIF data should be preserved in the output image.

</summary>

One of the following:

"keep"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%200">Link to this property</a>

"copyright"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%201">Link to this property</a>

"none"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata">Link to this property</a>

width: number

Maximum width in image pixels.

minimum1

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20width">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options">Link to this property</a>

neverRequireSignedURLs?: boolean

Indicates whether the variant can access an image without a signature, regardless of image access control.

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20neverRequireSignedURLs">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)%20%3E%20(property)%20variant">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.variants%20%3E%20(model)%20variant_get_response%20%3E%20(schema)>)

<details>

<summary>

VariantCreateResponse {variant }

</summary>

<details>

<summary>

variant?: Variant {id, options, neverRequireSignedURLs }

</summary>

id: string

maxLength99

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

options: Options {fit, height, metadata, width }

Allows you to define image resizing sizes for different use cases.

</summary>

<details>

<summary>

fit: "scale-down"| "contain"| "cover"| 2 more

The fit property describes how the width and height dimensions should be interpreted.

</summary>

One of the following:

"scale-down"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%200">Link to this property</a>

"contain"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%201">Link to this property</a>

"cover"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%202">Link to this property</a>

"crop"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%203">Link to this property</a>

"pad"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%204">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit">Link to this property</a>

height: number

Maximum height in image pixels.

minimum1

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20height">Link to this property</a>

<details>

<summary>

metadata: "keep"| "copyright"| "none"

What EXIF data should be preserved in the output image.

</summary>

One of the following:

"keep"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%200">Link to this property</a>

"copyright"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%201">Link to this property</a>

"none"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata">Link to this property</a>

width: number

Maximum width in image pixels.

minimum1

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20width">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options">Link to this property</a>

neverRequireSignedURLs?: boolean

Indicates whether the variant can access an image without a signature, regardless of image access control.

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20neverRequireSignedURLs">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)%20%3E%20(property)%20variant">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.variants%20%3E%20(model)%20variant_create_response%20%3E%20(schema)>)

<details>

<summary>

VariantEditResponse {variant }

</summary>

<details>

<summary>

variant?: Variant {id, options, neverRequireSignedURLs }

</summary>

id: string

maxLength99

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

options: Options {fit, height, metadata, width }

Allows you to define image resizing sizes for different use cases.

</summary>

<details>

<summary>

fit: "scale-down"| "contain"| "cover"| 2 more

The fit property describes how the width and height dimensions should be interpreted.

</summary>

One of the following:

"scale-down"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%200">Link to this property</a>

"contain"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%201">Link to this property</a>

"cover"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%202">Link to this property</a>

"crop"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%203">Link to this property</a>

"pad"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit%20%3E%20(member)%204">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20fit">Link to this property</a>

height: number

Maximum height in image pixels.

minimum1

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20height">Link to this property</a>

<details>

<summary>

metadata: "keep"| "copyright"| "none"

What EXIF data should be preserved in the output image.

</summary>

One of the following:

"keep"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%200">Link to this property</a>

"copyright"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%201">Link to this property</a>

"none"

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20metadata">Link to this property</a>

width: number

Maximum width in image pixels.

minimum1

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options%20%3E%20(property)%20width">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20options">Link to this property</a>

neverRequireSignedURLs?: boolean

Indicates whether the variant can access an image without a signature, regardless of image access control.

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant%20%3E%20(property)%20neverRequireSignedURLs">Link to this property</a>

</details>

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)%20%3E%20(property)%20variant">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.variants%20%3E%20(model)%20variant_edit_response%20%3E%20(schema)>)

<details>

<summary>

VariantDeleteResponse = unknown| string

</summary>

One of the following:

unknown

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_delete_response%20%3E%20(schema)%20%3E%20(variant)%200">Link to this property</a>

string

<a href="#(resource)%20images.v1.variants%20%3E%20(model)%20variant_delete_response%20%3E%20(schema)%20%3E%20(variant)%201">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v1.variants%20%3E%20(model)%20variant_delete_response%20%3E%20(schema)>)

#### ImagesV1Blobs

##### [Download image](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v1/subresources/blobs/methods/get)

client.images.v1.blobs.get(stringimageID, BlobGetParams {account\_id } params, RequestOptionsoptions?): Response

GET/accounts/{account\_id}/images/v1/{image\_id}/blob

#### ImagesV2

##### [List images V2](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v2/methods/list)

client.images.v2.list(V2ListParams {account\_id, continuation\_token, creator, 3 more } params, RequestOptionsoptions?): [V2ListResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v2%20%3E%20(model)%20v2_list_response%20%3E%20(schema)>) {continuation\_token, images }

GET/accounts/{account\_id}/images/v2

##### ModelsExpand Collapse

<details>

<summary>

V2ListResponse {continuation\_token, images }

</summary>

continuation\_token?: string| null

Continuation token to fetch next page. Passed as a query param when requesting List V2 api endpoint.

maxLength32

<a href="#(resource)%20images.v2%20%3E%20(model)%20v2_list_response%20%3E%20(schema)%20%3E%20(property)%20continuation_token">Link to this property</a>

<details>

<summary>

images?: Array&lt;<a href="https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)">Image</a> {id, creator, filename, 4 more } &gt;

</summary>

id?: string

Image unique identifier.

maxLength32

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

creator?: string| null

Can set the creator field with an internal user ID.

maxLength1024

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20creator">Link to this property</a>

filename?: string

Image file name.

maxLength255

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20filename">Link to this property</a>

meta?: unknown

User modifiable key-value store. Can be used for keeping references to another system of record for managing images. Metadata must not exceed 1024 bytes.

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20meta">Link to this property</a>

requireSignedURLs?: boolean

Indicates whether the image can be a accessed only using it’s UID. If set to true, a signed token needs to be generated with a signing key to view the image.

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20requireSignedURLs">Link to this property</a>

uploaded?: string

When the media item was uploaded.

formatdate-time

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20uploaded">Link to this property</a>

variants?: Array&lt;string&gt;

Object specifying available variants for an image.

<a href="#(resource)%20images.v1%20%3E%20(model)%20image%20%3E%20(schema)%20%3E%20(property)%20variants">Link to this property</a>

</details>

<a href="#(resource)%20images.v2%20%3E%20(model)%20v2_list_response%20%3E%20(schema)%20%3E%20(property)%20images">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v2%20%3E%20(model)%20v2_list_response%20%3E%20(schema)>)

#### ImagesV2Direct Uploads

##### [Create authenticated direct upload URL V2](https://developers.cloudflare.com/api/typescript/resources/images/subresources/v2/subresources/direct_uploads/methods/create)

client.images.v2.directUploads.create(DirectUploadCreateParams {account\_id, id, creator, 3 more } params, RequestOptionsoptions?): [DirectUploadCreateResponse](<https://developers.cloudflare.com/api/typescript/resources/images#(resource)%20images.v2.direct_uploads%20%3E%20(model)%20direct_upload_create_response%20%3E%20(schema)>) {id, uploadURL }

POST/accounts/{account\_id}/images/v2/direct\_upload

##### ModelsExpand Collapse

<details>

<summary>

DirectUploadCreateResponse {id, uploadURL }

</summary>

id?: string

Image unique identifier.

maxLength32

<a href="#(resource)%20images.v2.direct_uploads%20%3E%20(model)%20direct_upload_create_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

uploadURL?: string

The URL the unauthenticated upload can be performed to using a single HTTP POST (multipart/form-data) request.

<a href="#(resource)%20images.v2.direct_uploads%20%3E%20(model)%20direct_upload_create_response%20%3E%20(schema)%20%3E%20(property)%20uploadURL">Link to this property</a>

</details>

[Link to this property](<#(resource)%20images.v2.direct_uploads%20%3E%20(model)%20direct_upload_create_response%20%3E%20(schema)>)